package com.swtjface.flowchart.commands;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.commands.Command;
import com.swtjface.flowchart.model.*;

public class CreateCommand extends Command
{
  private Chart parent;
  private Activity child;
  private Rectangle rect;
  
  public void execute()
  {
    if (rect != null)
    {
      child.setLocation(rect.getLocation());
      if (!rect.isEmpty())
        child.setSize(rect.getSize());
    }
    parent.addChild(child);
  }
  
  public void setParent(Chart sa)
  {parent = sa;}

  public void setChild(Activity activity)
  {child = activity;}

  public void setConstraint(Rectangle bounds)
  {rect = bounds;}

  public void redo()
  {execute();}

  public void undo()
  {parent.removeChild(child);}
}