package com.swtjface.flowchart.commands;

import org.eclipse.draw2d.geometry.*;
import com.swtjface.flowchart.model.*;

public class SetConstraintCommand
  extends org.eclipse.gef.commands.Command
{
  private Point oldPos, newPos;
  private Dimension oldSize, newSize;
  private Activity act;
 
  public void execute()
  {
    oldSize = act.getSize();
    oldPos = act.getLocation();
    act.setLocation(newPos);
    act.setSize(newSize);
  }
  
  public void setLocation(Rectangle r)
  {
    setLocation(r.getLocation());
    setSize(r.getSize());
  }

  public void setLocation(Point p)
  {newPos = p;}

  public void setPart(Activity part)
  {this.act = part;}

  public void setSize(Dimension p)
  {newSize = p;}

  public void redo()
  {
    act.setSize(newSize);
    act.setLocation(newPos);
  }

  public void undo()
  {
    act.setSize(oldSize);
    act.setLocation(oldPos);
  }
}