package com.swtjface.flowchart.editpart;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import com.swtjface.flowchart.model.*;
import com.swtjface.flowchart.model.Process;

public class PartFactory implements EditPartFactory
{
  public EditPart createEditPart(EditPart context, Object model)
  {
    EditPart part = null;
    if (model instanceof Decision)
      part = new DecisionPart();
    else if (model instanceof Process)
      part = new ProcessPart();
    else if (model instanceof Terminator)
      part = new TerminatorPart();
    else if (model instanceof Path)
      part = new PathPart();
    else if (model instanceof Chart)
      part = new ChartPart();
    part.setModel(model);
    return part;
  }
}