package com.swtjface.flowchart.palette;

  import java.util.*;
  import com.swtjface.flowchart.model.*;
  import org.eclipse.gef.palette.*;
  import org.eclipse.jface.resource.*;
  
public class FlowchartPalette
{
  public static final String
  TERMINATOR_TEMPLATE = "TERM_TEMP",
  DECISION_TEMPLATE = "DEC_TEMP",
  PROCESS_TEMPLATE = "PROC_TEMP";
  
  public static PaletteRoot getPaletteRoot()
  {
    PaletteRoot root = new PaletteRoot();
    
    PaletteGroup toolGroup = new PaletteGroup("Chart Tools");
    List toolList = new ArrayList();
    
    ToolEntry tool = new SelectionToolEntry();
    toolList.add(tool);
    root.setDefaultEntry(tool);
    
    tool = new MarqueeToolEntry();
    toolList.add(tool);
    
    tool = new ConnectionCreationToolEntry(
      "Connection_Tool", "Used to connect multiple components", null,
      ImageDescriptor.getMissingImageDescriptor(),
      ImageDescriptor.getMissingImageDescriptor() );
    toolList.add(tool);
    toolGroup.addAll(toolList);
    
    PaletteGroup templateGroup =
      new PaletteGroup("Chart Templates");
    List templateList = new ArrayList();
    
    CombinedTemplateCreationEntry entry = new
      CombinedTemplateCreationEntry(
        "Terminator", "Start or End Component", TERMINATOR_TEMPLATE,
        new ModelFactory(TERMINATOR_TEMPLATE),
        ImageDescriptor.getMissingImageDescriptor(),
        ImageDescriptor.getMissingImageDescriptor());
    templateList.add(entry);
    
    entry = new CombinedTemplateCreationEntry(
      "Process", "Action within a flowchart", PROCESS_TEMPLATE,
      new ModelFactory(PROCESS_TEMPLATE),
      ImageDescriptor.getMissingImageDescriptor(),
      ImageDescriptor.getMissingImageDescriptor());
    templateList.add(entry);
    
    entry = new CombinedTemplateCreationEntry(
      "Decision", "Choosing between 'Yes' and 'No'", DECISION_TEMPLATE,
      new ModelFactory(DECISION_TEMPLATE),
      ImageDescriptor.getMissingImageDescriptor(),
      ImageDescriptor.getMissingImageDescriptor());
    templateList.add(entry);
    
    templateGroup.addAll(templateList);
    
    List rootList = new ArrayList();
    rootList.add(toolGroup);
    rootList.add(templateGroup);
    
    root.addAll(rootList);
    return root;
  }
}