package com.swtjface.flowchart.policies;

import org.eclipse.draw2d.*;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.*;
import com.swtjface.flowchart.commands.*;
import com.swtjface.flowchart.model.*;
import com.swtjface.flowchart.figures.*;
import com.swtjface.flowchart.editpart.*;

public class NodePolicy
  extends org.eclipse.gef.editpolicies.GraphicalNodeEditPolicy
{
  protected Connection createDummyConnection(Request req)
  {
    PolylineConnection conn = FigureFactory.createPathFigure();
    return conn;
  }
  
  protected Command getConnectionCompleteCommand(CreateConnectionRequest request)
  {
    PathCommand command = (PathCommand)request.getStartCommand();
    command.setTarget(getActivity());
    ConnectionAnchor ctor = getActivityPart().
      getTargetConnectionAnchor(request);
    if (ctor == null)
      return null;
    command.setTargetName(getActivityPart().
      mapTargetConnectionAnchorToName(ctor));
    return command;
  }

  protected Command getConnectionCreateCommand
    (CreateConnectionRequest request)
  {
    PathCommand command = new PathCommand();
    command.setPath(new Path());
    command.setSource(getActivity());
    ConnectionAnchor ctor = getActivityPart().
      getSourceConnectionAnchor(request);
    command.setSourceName(getActivityPart().
    mapSourceConnectionAnchorToName(ctor));
    request.setStartCommand(command);
    return command;
  }

  protected ActivityPart getActivityPart()
  {return (ActivityPart) getHost();}

  protected Activity getActivity()
  {return (Activity) getHost().getModel();}

  protected Command getReconnectTargetCommand
    (ReconnectRequest request)
  {
    PathCommand cmd = new PathCommand();
    cmd.setPath((Path)request.getConnectionEditPart().getModel());
    ConnectionAnchor ctor = getActivityPart().
      getTargetConnectionAnchor(request);
    cmd.setTarget(getActivity());
      cmd.setTargetName(getActivityPart().
    mapTargetConnectionAnchorToName(ctor));
    return cmd;
  }

  protected Command getReconnectSourceCommand
    (ReconnectRequest request)
  {
    PathCommand cmd = new PathCommand();
    cmd.setPath((Path)request.getConnectionEditPart().getModel());
    ConnectionAnchor ctor = getActivityPart().
      getSourceConnectionAnchor(request);
    cmd.setSource(getActivity());
    cmd.setSourceName(getActivityPart().
      mapSourceConnectionAnchorToName(ctor));
    return cmd;
  }

  protected ActivityFigure getActivityFigure()
  {
    return (ActivityFigure)((GraphicalEditPart)getHost()).getFigure();
  }
}